<template>
  <div :class="['accordion', isExpand && 'is-expand']">
    <div class="header" @click="toggleExpand()">
      <div :class="['icon', iconTextBackground && 'withBackground']">
        {{ iconText }}
      </div>
      <div class="header-text">{{ headerText }}</div>
      <div class="space" />
      <div :class="['botton-expand', isExpand && 'is-expand']">
        <i :class="['ic-sm-arrow', 'iconArrow']" />
      </div>
    </div>
    <transition name="slide-down">
      <div v-show="isExpand" class="body-container">
        <div
          :class="['body', c.image && 'imageView']"
          v-for="(c, index) in content"
          :key="c.title"
        >
          <img v-if="c.image" class="image" :src="c.image" :srcset="c.srcset" />
          <div v-else class="number-disc">{{ index + 1 }}</div>
          <div class="text">
            <div v-if="c.title" class="title">{{ c.title }}</div>
            <div
              class="content"
              v-html="c.text"
              @click="clickOnContent($event)"
            />
          </div>
        </div>
        <div class="space" />
      </div>
    </transition>
  </div>
</template>

<script>
export default {
  props: {
    iconText: {
      type: String,
      required: true
    },

    headerText: {
      type: String,
      required: true
    },

    content: {
      type: Array,
      required: true
    },

    iconTextBackground: {
      type: Boolean
    }
  },

  data() {
    return {
      isExpand: false
    };
  },

  methods: {
    toggleExpand() {
      this.isExpand = !this.isExpand;
    },

    expand() {
      this.isExpand = true;
    },

    collapse() {
      this.isExpand = false;
    },

    clickOnContent(event) {
      if (event.target.attributes.hash) {
        this.$emit("onAnchorClick", event.target.attributes.hash.value);
      }
    }
  }
};
</script>

<style lang="scss" scoped>
.accordion /deep/.underline {
  text-decoration: underline;
  color: $color-primary-grey;
  &:hover {
    text-decoration: underline;
  }
}
.accordion /deep/.anchor {
  text-decoration: underline;
  color: $color-skm-red;
  cursor: pointer;
}

.slide-down {
  &-enter-active {
    overflow: hidden;
    transition: max-height 0.2s ease-in-out;
  }

  &-leave-active {
    overflow: hidden;
    transition: max-height 0.2s ease-in-out;
  }

  &-enter,
  &-leave-to {
    max-height: 0;
  }

  &-enter-to,
  &-leave {
    max-height: 1000px;
  }
}

.accordion {
  width: 100%;
  background: $color-white;
  margin: 20px 0px 0px 0px;
  .header {
    width: 100%;
    height: 80px;
    display: inline-flex;
    flex-direction: row;
    border-bottom: 0.5px solid #cad1dd;
    align-items: center;
    cursor: pointer;
    .icon {
      height: 40px;
      width: 40px;
      border-radius: 4px;
      margin: 0 20px;
      font-size: 28px;
      line-height: 40px;
      color: $color-skm-red;
      text-align: center;
      &.withBackground {
        background: $color-skm-red;
        color: $color-white;
      }
    }
    .header-text {
      height: 40px;
      font-size: 28px;
    }
    .space {
      display: block;
      width: 1px;
      height: 10px;
      flex-grow: 1;
    }
    .botton-expand {
      width: 40px;
      height: 40px;
      margin: 0 20px;
      text-align: center;
      padding: 10px 0px;
      transform: rotate(0deg);
      transition: all 0.3s;
      color: $color-primary-grey;
      cursor: pointer;

      &.is-expand {
        transition: all 0.3s;
        transform: rotate(180deg);
      }
    }
  }

  .body-container {
    .space {
      background: $color-genesis-white;
      width: 100%;
      height: 0px;
      margin-top: 0px;
    }
    .body {
      width: 100%;
      background: $color-white;
      display: flex;
      flex-direction: row;
      &:first-child {
        margin-top: 30px;
      }
      &.imageView {
        margin-top: 0px;
        padding: 20px;
        .text {
          margin: 10px 30px;
        }
      }
      .image {
        padding-right: 20px;
        flex-shrink: 0;
        width: 405px;
        // height: 260px;
      }
      .number-disc {
        flex-shrink: 0;
        display: block;
        width: 16px;
        height: 16px;
        background: $color-secondary-black;
        border-radius: 50%;
        text-align: center;
        color: $color-white;
        line-height: 16px;
        font-size: 12px;
        font-weight: 500;
        margin: 6px 10px 20px 50px;
      }
      .text {
        display: flex;
        flex-direction: column;
        margin-right: 40px;
        margin-bottom: 20px;
        .title {
          font-size: 18px;
          font-weight: 500;
          margin: 0 0 10px 0px;
        }
        .content {
          color: $color-primary-grey;
          font-size: 16px;
          line-height: 1.75;
        }
      }
    }
  }

  @include media-breakpoint-down(md) {
    .header {
      height: 64px;
      .icon {
        height: 32px;
        width: 32px;
        font-size: 24px;
        line-height: 32px;
      }

      .header-text {
        height: 32px;
        font-size: 20px;
      }
    }
    .body-container {
      .space {
        margin-top: 40px;
        height: 10px;
      }
      .body {
        margin-top: 6px;
        &:first-child {
          margin-top: 14px;
        }
        &.imageView {
          margin-top: 0px;
          flex-direction: column;
          padding: 20px 0px;
          .text {
            margin: 0 20px;
            .title {
              margin-top: 20px;
              position: relative;
              &:before {
                content: "";
                position: absolute;
                margin-top: 5px;
                left: -20px;
                width: 8px;
                height: 16px;
                background: $color-skm-red;
                border: none;
              }
            }
          }
        }
        .image {
          padding-right: 0px;
          margin: auto;
        }
        .number-disc {
          margin: 6px 0px 0px 20px;
        }
        .text {
          margin: 0 20px 0 10px;
        }
      }
    }
  }

  @include media-breakpoint-down(sm) {
    margin: 0px;
    .body-container {
      .body {
        .image {
          width: 375px;
          height: 240px;
        }
      }
    }
  }
}
.accordion:last-child {
  .body-container {
    .space {
      background: $color-white;
      height: 10px;
    }
  }
}
</style>
